/* 
 * Copyright (c) 2010 Michael J. Wilson
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

// Michael J. Wilson
// Music 256a Fall 2010
// Final Project

#include <QVBoxLayout>
#include <QScrollArea>
#include <QApplication>
#include <QCloseEvent>
#include <QThread>

#include "WidgetMain.h"
#include "WidgetTransport.h"
#include "WidgetTrackArea.h"
#include "Utility.h"

#include "RtAudio.h"

WidgetMain::WidgetMain(QWidget* parent)
    : QWidget(parent)
{
    QVBoxLayout* layout = new QVBoxLayout();

    WidgetTransport* transport = new WidgetTransport(this);
    layout->addWidget(transport);

    track_area = new WidgetTrackArea(this);
    QScrollArea* scroll_area = new QScrollArea(this);
    scroll_area->setWidgetResizable(true);
    scroll_area->setBackgroundRole(QPalette::Dark);
    scroll_area->setWidget(track_area);
    layout->addWidget(scroll_area);

    setLayout(layout);

    // Make connections
    connect(transport, SIGNAL(new_track()), track_area, SLOT(add_track()));
    connect(transport, SIGNAL(play_signal(unsigned int)), track_area, SLOT(play_beat(unsigned int)));
    connect(transport, SIGNAL(stop_signal()), track_area, SLOT(stop_playing()));
}

float WidgetMain::get_next_sample()
{
    float result = 0.0;
    result = track_area->get_next_sample();
    return result;
}

