/* 
 * Copyright (c) 2010 Michael J. Wilson
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

// Michael J. Wilson
// Music 256a Fall 2010
// Final Project

#ifndef __WIDGET_TRANSPORT__
#define __WIDGET_TRANSPORT__

#include <QWidget>

class SongData;
class QTimer;

/// QT Widget for displaying the transport at the top of the screen
class WidgetTransport : public QWidget
{
    Q_OBJECT

public:
    ~WidgetTransport();
    WidgetTransport(QWidget* parent = 0);

public slots:
    void new_track_button_slot();
    void play_button_slot();
    void stop_button_slot();
    void timer_slot();
    void change_tempo_slot(int new_tempo);

signals:
    void new_track();
    void play_signal(unsigned int beat);
    void stop_signal();

private:
    SongData* m_song_data;
    QTimer* timer;
};

#endif
